-- PBARS_HEALTH/MANA left, bottom, width, height, r, g, b, a, f

local hWidth, mWidth, hHeight, mHeight, timerInt, hr, hg, hb, ha, mr, mg, mb, ma
local playerName = UnitName("player")

local hframe, mframe

local timer = 0.0
local hRatio = 1.0
local mRatio = 1.0
local rleft, rbottom, rwidth, rheight
local htexture, mtexture

local function onUpdate(self,elapsed)
	local tmp
	timer = timer + elapsed
	if timer > timerInt then
		hRatio = UnitHealth(playerName) / UnitHealthMax(playerName)
		mRatio = UnitPower(playerName) / UnitPowerMax(playerName)
		
		rleft, rbottom, rwidth, rheight = hframe:GetBoundsRect()
		hframe:ClearAllPoints()
		hframe:SetPoint("TOPLEFT", WorldFrame, "BOTTOMLEFT", rleft, rbottom + hHeight)
		tmp = hWidth * hRatio
		if tmp == 0 then
			tmp = 1
		end
		hframe:SetWidth(tmp)

		rleft, rbottom, rwidth, rheight = mframe:GetBoundsRect()
		mframe:ClearAllPoints()
		mframe:SetPoint("TOPLEFT", WorldFrame, "BOTTOMLEFT", rleft, rbottom + mHeight)
		tmp = mWidth * mRatio
		if tmp == 0 then
			tmp = 1
		end
		mframe:SetWidth(tmp)

		timer = 0
	end
end

local function onMouseDown(self, button)
	if button == "LeftButton" and IsShiftKeyDown() and not self.isMoving then
		self:StartMoving();
		self.isMoving = true;
	end
end

local function onMouseUp(self, button)
	if button == "LeftButton" and self.isMoving then
		self:StopMovingOrSizing();
		self.isMoving = false;
		-- left, bottom
		PBARS_HEALTH[1], PBARS_HEALTH[2], _, _ = hframe:GetBoundsRect()
		PBARS_MANA[1],   PBARS_MANA[2],   _, _ = mframe:GetBoundsRect()
	end
end

local eframe = CreateFrame("Frame", "EventFrame", UIParent)
eframe:RegisterEvent("ADDON_LOADED")
function eframe:OnEvent(event, arg)
if event == "ADDON_LOADED" and arg == "PlayerBars" then

	if PBARS_HEALTH == nil then
		PBARS_HEALTH = {}
	end
	if PBARS_MANA == nil then
		PBARS_MANA = {}
	end
	
	-- PBARS_HEALTH/MANA left, bottom, width, height, r, g, b, a, f
	hWidth = PBARS_HEALTH[3] or 265
	mWidth = PBARS_MANA[3] or 265
	hHeight = PBARS_HEALTH[4] or 6
	mHeight = PBARS_MANA[4] or 6
	timerInt = PBARS_HEALTH[9] or 0.2
	hr = PBARS_HEALTH[5] or 0
	hg = PBARS_HEALTH[6] or 0.7
	hb = PBARS_HEALTH[7] or 0
	ha = PBARS_HEALTH[8] or 1
	
	-- mana bar colors
	local pTypes = {
		{"MANA", 0,0,0.7,1}, 
		{"RAGE", 0.7,0,0,1}, 
		{"FOCUS", 0.6,0.4,0.3,1}, 
		{"ENERGY", 0.7,0.7,0,1}, 
		{"COMBO_POINTS", 0.5,0.5,0.5,1}, 
		{"RUNES", 0.5,0.5,0.5,1}, 
		{"RUNIC_POWER", 0.5,0.5,0.5,1}, 
		{"SOUL_SHARDS", 0.5,0.5,0.5,1}, 
		{"ECLIPSE", 0.5,0.5,0.5,1}, 
		{"HOLY_POWER", 0.5,0.5,0.5,1}
	}
	local pt = pTypes[UnitPowerType("player")+1]

	mr = PBARS_MANA[5] or pt[2]
	mg = PBARS_MANA[6] or pt[3]
	mb = PBARS_MANA[7] or pt[4]
	ma = PBARS_MANA[8] or pt[5]
	
	
	local centerX = GetScreenWidth()/2
	local centerY = GetScreenHeight()/2
	local startHX = PBARS_HEALTH[1] or centerX
	local startMX = PBARS_MANA[1] or centerX
	local startHY = centerY
	local startMY = centerY - mHeight
	
	if PBARS_HEALTH[2] then
		startHY = PBARS_HEALTH[2] + hHeight
	end
	if PBARS_MANA[2] then
		startMY = PBARS_MANA[2] + mHeight
	end
	
	hframe = CreateFrame("Frame", "HealthFrame", UIParent)

	hframe:SetClampedToScreen(true)
	hframe:SetSize(hWidth, hHeight) 
	hframe:SetPoint("TOPLEFT", WorldFrame, "BOTTOMLEFT", startHX, startHY)
	htexture = hframe:CreateTexture() 
	htexture:SetAllPoints()
	htexture:SetTexture(hr, hg, hb, ha) 
	hframe.background = htexture
	
	hframe:SetMovable(true)
	hframe:EnableMouse(true)
	
	mframe = CreateFrame("Frame", "ManaFrame", UIParent)
	
	mframe:SetClampedToScreen(true)
	mframe:SetSize(mWidth, mHeight) 
	mframe:SetPoint("TOPLEFT", WorldFrame, "BOTTOMLEFT", startMX, startMY)
	mtexture = mframe:CreateTexture() 
	mtexture:SetAllPoints()
	mtexture:SetTexture(mr, mg, mb, ma) 
	mframe.background = mtexture
	
	hframe:SetMovable(true)
	hframe:EnableMouse(true)
	
	mframe:SetMovable(true)
	mframe:EnableMouse(true)
	
	hframe:SetScript("OnMouseDown", onMouseDown)
	hframe:SetScript("OnMouseUp", onMouseUp)
	mframe:SetScript("OnMouseDown", onMouseDown)
	mframe:SetScript("OnMouseUp", onMouseUp)

	hframe:SetScript("OnUpdate", onUpdate)
	
	print(format("|cFFffff00PlayerBars v0.2 loaded|r"))

end
end
eframe:SetScript("OnEvent", eframe.OnEvent)

SLASH_PLAYERBARS1 = "/pbars"
function SlashCmdList.PLAYERBARS(msg, editbox)
	local hupdate = false
	local mupdate = false
	local rleft, rbottom, rheight
	local cmd, args = strsplit(" ", strlower(msg), 2)
	local r, g, b, a
	if cmd == "" then
		if hframe:IsVisible() then
			hframe:Hide()
			mframe:Hide()
			hframe:SetScript("OnUpdate", nil)
		else
			hframe:Show()
			mframe:Show()
			hframe:SetScript("OnUpdate", onUpdate)
		end
	
	elseif cmd == "f" and tonumber(args) > 0 then
		timerInt = tonumber(args)
		PBARS_HEALTH[9] = timerInt
	
	elseif cmd == "hw" and tonumber(args) > 0 then
		hWidth = tonumber(args)
		PBARS_HEALTH[3] = hWidth
		hupdate = true
	elseif cmd == "hh" and tonumber(args) > 0 then
		hHeight = tonumber(args)
		PBARS_HEALTH[4] = hHeight
		hupdate = true	
	elseif cmd == "hc" and args ~= "" then
		r, g, b, a = strsplit(" ", strlower(args), 4)
		htexture:SetTexture(r, g, b, a)
		hframe.background = htexture
		PBARS_HEALTH[5] = r
		PBARS_HEALTH[6] = g
		PBARS_HEALTH[7] = b
		PBARS_HEALTH[8] = a
		
	elseif cmd == "mw" and tonumber(args) > 0 then
		mWidth = tonumber(args)
		PBARS_MANA[3] = mWidth
		mupdate = true
	elseif cmd == "mh" and tonumber(args) > 0 then
		mHeight = tonumber(args)
		PBARS_MANA[4] = mHeight
		mupdate = true	
	elseif cmd == "mc" and args ~= "" then
		r, g, b, a = strsplit(" ", strlower(args), 4)
		mtexture:SetTexture(r, g, b, a)
		mframe.background = mtexture
		PBARS_MANA[5] = r
		PBARS_MANA[6] = g
		PBARS_MANA[7] = b
		PBARS_MANA[8] = a
	end
	if hupdate then
		hframe:SetSize(hWidth * hRatio, hHeight)
	end
	if mupdate then
		mframe:SetSize(mWidth * mRatio, mHeight)
	end
end



